## kore 1.2.3

=== Makefile ===
# Kore Makefile

CC?=gcc
PREFIX?=/usr/local
KORE=kore
INSTALL_DIR=$(PREFIX)/bin
INCLUDE_DIR=$(PREFIX)/include/kore

S_SRC=	src/kore.c src/accesslog.c src/auth.c src/buf.c src/cli.c src/config.c \
	src/connection.c src/domain.c src/http.c src/mem.c src/module.c \
	src/net.c src/pool.c src/spdy.c src/timer.c src/validator.c \
	src/utils.c src/websocket.c src/worker.c src/zlib_dict.c
S_OBJS=	$(S_SRC:.c=.o)

CFLAGS+=-Wall -Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=-Wsign-compare -Iincludes -g
CFLAGS+=-DPREFIX='"$(PREFIX)"'
LDFLAGS+=-rdynamic -lssl -lcrypto -lz

ifneq ("$(DEBUG)", "")
	CFLAGS+=-DKORE_DEBUG
endif

ifneq ("$(KORE_PEDANTIC_MALLOC)", "")
	CFLAGS+=-DKORE_PEDANTIC_MALLOC
endif

ifneq ("$(BENCHMARK)", "")
	CFLAGS+=-DKORE_BENCHMARK
	LDFLAGS=-rdynamic -lz -lcrypto
endif

ifneq ("$(PGSQL)", "")
	S_SRC+=src/pgsql.c
	LDFLAGS+=-L$(shell pg_config --libdir) -lpq
	CFLAGS+=-I$(shell pg_config --includedir) -DKORE_USE_PGSQL \
	    -DPGSQL_INCLUDE_PATH="\"$(shell pg_config --includedir)\""
endif

ifneq ("$(TASKS)", "")
	S_SRC+=src/tasks.c
	LDFLAGS+=-lpthread
	CFLAGS+=-DKORE_USE_TASKS
endif

OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
ifeq ("$(OSNAME)", "darwin")
	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
	S_SRC+=src/bsd.c
else ifeq ("$(OSNAME)", "linux")
	CFLAGS+=-D_GNU_SOURCE=1
	LDFLAGS+=-ldl
	S_SRC+=src/linux.c
else
	S_SRC+=src/bsd.c
endif

all: $(S_OBJS)
	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KORE)

install:
	mkdir -p $(INCLUDE_DIR)
	mkdir -p $(INSTALL_DIR)
	install -m 555 $(KORE) $(INSTALL_DIR)/$(KORE)
	install -m 644 includes/*.h $(INCLUDE_DIR)

uninstall:
	rm -f $(INSTALL_DIR)/$(KORE)
	rm -rf $(INCLUDE_DIR)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	find . -type f -name \*.o -exec rm {} \;
	rm -f $(KORE)

.PHONY: clean

=== docker/Makefile ===
all: build app

build:
	docker build -t kore-build -f build/Dockerfile build/
	docker tag kore-build kore/build

app:
	docker build -t kore-app -f app/Dockerfile app/
	docker tag kore-app kore/app

clean:
	docker rmi -f kore-build kore-app

.PHONY: all build app clean

=== examples/ktunnel/client/Makefile ===
#
# You probably want to change the include and library
# paths before compiling.
#

CFLAGS+=-Wall -Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=-Wsign-compare -Iincludes -g
CFLAGS+=-I../../openssl-1.0.1i/include

all:
	gcc $(CFLAGS) -c client.c -o client.o
	gcc -L../../openssl-1.0.1i/ client.o -o client -lcrypto -lssl

clean:
	rm -f client *.o

=== debian/changelog ===
kore (1.2.3-5) unstable; urgency=medium

  * debian/kore.1: Remove the redundant sentence in the manual.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Fri, 11 Dec 2015 10:27:07 +0800

kore (1.2.3-4) unstable; urgency=medium

  * Add the runtime dependencies.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Sun, 06 Dec 2015 19:49:18 +0800

kore (1.2.3-3) unstable; urgency=medium

  * debian/patches/debian.patch: Add LFS support.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 24 Nov 2015 21:10:43 +0800

kore (1.2.3-2) unstable; urgency=medium

  * debian/patches/typos.patch: Fix typos.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 17 Nov 2015 19:26:14 +0800

kore (1.2.3-1) unstable; urgency=low

  * Initial release (Closes: #802854)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 20 Oct 2015 21:06:24 +0800

=== debian/control ===
Source: kore
Section: httpd
Priority: optional
Maintainer: Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libssl-dev, libpq-dev
Standards-Version: 3.9.6
Homepage: https://kore.io
Vcs-Git: git://anonscm.debian.org/collab-maint/kore.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/kore.git

Package: kore
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libc-dev, libssl-dev, libpq-dev
Recommends: gcc | gcc-5 | gcc-4.9 | gcc-4.8 |
            clang | clang-3.7 | clang-3.6 | clang-3.5 | clang-3.4
Suggests: postgresql
Description: Fast SPDY capable web server for web development in C
 Kore is an easy to use web application framework for writing scalable web APIs
 in C.
 .
 Its main goals are security, scalability and allowing rapid development and
 deployment of such APIs.
 .
 Because of this Kore is an ideal candidate for building robust, scalable and
 secure web things.

=== debian/watch ===
version=3

https://kore.io/downloads .*/kore-(.*)-release\.tgz

## kore 2.0.0

=== Makefile ===
# Kore Makefile

CC?=gcc
PREFIX?=/usr/local
OBJDIR?=obj
KORE=kore
INSTALL_DIR=$(PREFIX)/bin
INCLUDE_DIR=$(PREFIX)/include/kore

S_SRC=	src/kore.c src/buf.c src/cli.c src/config.c src/connection.c \
	src/domain.c src/mem.c src/msg.c src/module.c src/net.c \
	src/pool.c src/timer.c src/utils.c src/worker.c src/keymgr.c

CFLAGS+=-Wall -Werror -Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=-Wsign-compare -Iincludes -std=c99 -pedantic
CFLAGS+=-DPREFIX='"$(PREFIX)"'
LDFLAGS=-rdynamic -lssl -lcrypto

ifneq ("$(DEBUG)", "")
	CFLAGS+=-DKORE_DEBUG -g
	NOOPT=1
endif

ifneq ("$(NOOPT)", "")
	CFLAGS+=-O0
else
	CFLAGS+=-O2
endif

ifneq ("$(NOHTTP)", "")
	CFLAGS+=-DKORE_NO_HTTP
else
	S_SRC+= src/auth.c src/accesslog.c src/http.c \
		src/validator.c src/websocket.c
endif

ifneq ("$(NOTLS)", "")
	CFLAGS+=-DKORE_NO_TLS
	ifneq ("$(NOHTTP)", "")
		LDFLAGS=-rdynamic
	else
		LDFLAGS=-rdynamic -lcrypto
	endif
endif

ifneq ("$(PGSQL)", "")
	S_SRC+=src/pgsql.c
	LDFLAGS+=-L$(shell pg_config --libdir) -lpq
	CFLAGS+=-I$(shell pg_config --includedir) -DKORE_USE_PGSQL \
	    -DPGSQL_INCLUDE_PATH="\"$(shell pg_config --includedir)\""
endif

ifneq ("$(TASKS)", "")
	S_SRC+=src/tasks.c
	LDFLAGS+=-lpthread
	CFLAGS+=-DKORE_USE_TASKS
endif

ifneq ("$(JSONRPC)", "")
	S_SRC+=src/jsonrpc.c
	LDFLAGS+=-lyajl
	CFLAGS+=-DKORE_USE_JSONRPC
endif

OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
ifeq ("$(OSNAME)", "darwin")
	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
	S_SRC+=src/bsd.c
else ifeq ("$(OSNAME)", "linux")
	CFLAGS+=-D_GNU_SOURCE=1
	LDFLAGS+=-ldl
	S_SRC+=src/linux.c
else
	S_SRC+=src/bsd.c
	ifneq ("$(JSONRPC)", "")
		CFLAGS+=-I/usr/local/include
		LDFLAGS+=-L/usr/local/lib
	endif
endif

S_OBJS=	$(S_SRC:src/%.c=$(OBJDIR)/%.o)

$(KORE): $(OBJDIR) $(S_OBJS)
	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KORE)

objects: $(OBJDIR) $(S_OBJS)

all: $(KORE)

$(OBJDIR):
	@mkdir -p $(OBJDIR)

install:
	mkdir -p $(INCLUDE_DIR)
	mkdir -p $(INSTALL_DIR)
	install -m 555 $(KORE) $(INSTALL_DIR)/$(KORE)
	install -m 644 includes/*.h $(INCLUDE_DIR)

uninstall:
	rm -f $(INSTALL_DIR)/$(KORE)
	rm -rf $(INCLUDE_DIR)

$(OBJDIR)/%.o: src/%.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	find . -type f -name \*.o -exec rm {} \;
	rm -rf $(KORE) $(OBJDIR)

.PHONY: all clean

=== debian/changelog ===
kore (2.0.0-4) unstable; urgency=medium

  * debian/patches/Add-support-for-openssl-1.1.0-release-line.patch: Add the
    Debian bug information. (Closes: #858939)
  * debian/patches/Deal-with-the-Host-header-in-a-way-IPv6-hosts-work.patch:
    Add the Debian bug information. (Closes: #853478)
  * debian/patches/debian.patch: Fix dpkg-buildflags-missing warning.
  * debian/control: Update Debian Policy version to 4.1.4.2.
  * debian/watch: Fix the watch file for uscan.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Sat, 23 Jun 2018 19:40:13 +0800

kore (2.0.0-3) unstable; urgency=medium

  * debian/control: Migrate Git repository to salsa.debian.org, update the
    maintainer's email, simplify the package dependency.
  * debian/patches/Add-support-for-openssl-1.1.0-release-line.patch: Support
    openssl 1.1.0. (Closes: #858939)
  * Deal-with-the-Host-header-in-a-way-IPv6-hosts-work.patch: Fix GCC 7 build.
    (Closes: #853478)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Fri, 22 Jun 2018 23:03:27 +0800

kore (2.0.0-2) unstable; urgency=medium

  * Fix the maybe-uninitialized error for va_list.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Sat, 19 Nov 2016 17:52:29 +0800

kore (2.0.0-1) unstable; urgency=medium

  * debian/control: Update Standards-Version to 3.9.8 and Vcs-Git to HTTPS.
  * debian/control: Depend on libssl1.0-dev instead because of the upstream.
    (Closes: #828368)
  * Bump to 2.0.0

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 15 Nov 2016 20:03:48 +0800

=== debian/control ===
Source: kore
Section: httpd
Priority: optional
Maintainer: Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>
Build-Depends: debhelper (>= 9.0.0), libssl-dev, libpq-dev
Standards-Version: 4.1.4.2
Homepage: https://kore.io
Vcs-Git: https://salsa.debian.org/debian/kore.git
Vcs-Browser: https://salsa.debian.org/debian/kore

Package: kore
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libc-dev, libssl-dev, libpq-dev
Recommends: gcc | clang | c-compiler
Suggests: postgresql
Description: Fast SPDY capable web server for web development in C
 Kore is an easy to use web application framework for writing scalable web APIs
 in C.
 .
 Its main goals are security, scalability and allowing rapid development and
 deployment of such APIs.
 .
 Because of this Kore is an ideal candidate for building robust, scalable and
 secure web things.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export PREFIX=/usr
export TASKS=1
export PGSQL=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

## kore 3.3.1

=== Makefile ===
# Kore Makefile

CC?=cc
PREFIX?=/usr/local
OBJDIR?=obj
KORE=kore
KODEV=kodev/kodev
KORE_CRYPTO?=crypto
INSTALL_DIR=$(PREFIX)/bin
MAN_DIR=$(PREFIX)/share/man
SHARE_DIR=$(PREFIX)/share/kore
INCLUDE_DIR=$(PREFIX)/include/kore

VERSION=src/version.c

S_SRC=	src/kore.c src/buf.c src/config.c src/connection.c \
	src/domain.c src/filemap.c src/fileref.c src/mem.c src/msg.c \
	src/module.c src/net.c src/pool.c src/runtime.c src/timer.c \
	src/utils.c src/worker.c src/keymgr.c $(VERSION)

FEATURES=
FEATURES_INC=

CFLAGS+=-Wall -Werror -Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=-Wsign-compare -Iinclude/kore -std=c99 -pedantic
CFLAGS+=-DPREFIX='"$(PREFIX)"' -fstack-protector-all

ifneq ("$(OPENSSL_PATH)", "")
CFLAGS+=-I$(OPENSSL_PATH)/include
LDFLAGS=-rdynamic -L$(OPENSSL_PATH) -lssl -l$(KORE_CRYPTO)
else
LDFLAGS=-rdynamic -lssl -l$(KORE_CRYPTO)
endif

ifneq ("$(KORE_SINGLE_BINARY)", "")
	CFLAGS+=-DKORE_SINGLE_BINARY
	FEATURES+=-DKORE_SINGLE_BINARY
endif

ifneq ("$(DEBUG)", "")
	CFLAGS+=-DKORE_DEBUG -g
	FEATURES+=-DKORE_DEBUG
	NOOPT=1
endif

ifneq ("$(NOOPT)", "")
	CFLAGS+=-O0
else
	CFLAGS+=-O2
endif

ifneq ("$(NOSENDFILE)", "")
	CFLAGS+=-DKORE_NO_SENDFILE
endif

ifneq ("$(NOHTTP)", "")
	CFLAGS+=-DKORE_NO_HTTP
	FEATURES+=-DKORE_NO_HTTP
else
	S_SRC+= src/auth.c src/accesslog.c src/http.c \
		src/validator.c src/websocket.c
endif

ifneq ("$(NOTLS)", "")
	CFLAGS+=-DKORE_NO_TLS
	FEATURES+=-DKORE_NO_TLS
	ifneq ("$(NOHTTP)", "")
		LDFLAGS=-rdynamic
	else
		LDFLAGS=-rdynamic -l$(KORE_CRYPTO)
	endif
endif

ifneq ("$(PGSQL)", "")
	S_SRC+=src/pgsql.c
	LDFLAGS+=-L$(shell pg_config --libdir) -lpq
	CFLAGS+=-I$(shell pg_config --includedir) -DKORE_USE_PGSQL \
	    -DPGSQL_INCLUDE_PATH="\"$(shell pg_config --includedir)\""
	FEATURES+=-DKORE_USE_PGSQL
	FEATURES_INC+=-I$(shell pg_config --includedir)
endif

ifneq ("$(TASKS)", "")
	S_SRC+=src/tasks.c
	LDFLAGS+=-lpthread
	CFLAGS+=-DKORE_USE_TASKS
	FEATURES+=-DKORE_USE_TASKS
endif

ifneq ("$(JSONRPC)", "")
	S_SRC+=src/jsonrpc.c
	LDFLAGS+=-lyajl
	CFLAGS+=-DKORE_USE_JSONRPC
	FEATURES+=-DKORE_USE_JSONRPC
endif

ifneq ("$(PYTHON)", "")
	S_SRC+=src/python.c
	KORE_PYTHON_LIB?=$(shell python3-config --ldflags)
	KORE_PYTHON_INC?=$(shell python3-config --includes)
	LDFLAGS+=$(KORE_PYTHON_LIB)
	CFLAGS+=$(KORE_PYTHON_INC) -DKORE_USE_PYTHON
	FEATURES+=-DKORE_USE_PYTHON
	FEATURES_INC+=$(KORE_PYTHON_INC)
endif

OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
ifeq ("$(OSNAME)", "freebsd")
	KORE_CURL_LIB=-L/usr/local/lib -lcurl
	KORE_CURL_INC=-I/usr/local/include
endif

ifneq ("$(CURL)", "")
	S_SRC+=src/curl.c
	KORE_CURL_LIB?=$(shell pkg-config --libs libcurl)
	KORE_CURL_INC?=$(shell pkg-config --cflags libcurl)
	LDFLAGS+=$(KORE_CURL_LIB)
	CFLAGS+=$(KORE_CURL_INC) -DKORE_USE_CURL
	FEATURES+=-DKORE_USE_CURL
	FEATURES_INC+=$(KORE_CURL_INC)
endif

ifneq ("$(SANITIZE)", "")
	CFLAGS+=-fsanitize=$(SANITIZE)
	LDFLAGS+=-fsanitize=$(SANITIZE)
endif

ifeq ("$(OSNAME)", "darwin")
	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
	S_SRC+=src/bsd.c
else ifeq ("$(OSNAME)", "linux")
	CFLAGS+=-D_GNU_SOURCE=1 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
	LDFLAGS+=-ldl
	S_SRC+=src/linux.c
else
	S_SRC+=src/bsd.c
	ifneq ("$(JSONRPC)", "")
		CFLAGS+=-I/usr/local/include
		LDFLAGS+=-L/usr/local/lib
	endif
endif

S_OBJS=	$(S_SRC:src/%.c=$(OBJDIR)/%.o)

all: $(VERSION) $(KORE) $(KODEV)

$(VERSION): force
	@if [ -d .git ]; then \
		GIT_REVISION=`git rev-parse --short=8 HEAD`; \
		GIT_BRANCH=`git rev-parse --abbrev-ref HEAD`; \
		rm -f $(VERSION); \
		printf "const char *kore_version = \"%s-%s\";\n" \
		    $$GIT_BRANCH $$GIT_REVISION > $(VERSION); \
	elif [ -f RELEASE ]; then \
		printf "const char *kore_version = \"%s\";\n" \
		    `cat RELEASE` > $(VERSION); \
	else \
		echo "No version information found (no .git or RELEASE)"; \
		exit 1; \
	fi

$(KODEV):
	$(MAKE) -C kodev

$(KORE): $(OBJDIR) $(S_OBJS)
	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KORE)
	@echo $(FEATURES) $(FEATURES_INC) > kore.features

objects: $(OBJDIR) $(S_OBJS)
	@echo $(LDFLAGS) > $(OBJDIR)/ldflags
	@echo "$(FEATURES) $(FEATURES_INC)" > $(OBJDIR)/features

$(OBJDIR):
	@mkdir -p $(OBJDIR)

install:
	mkdir -p $(SHARE_DIR)
	mkdir -p $(INCLUDE_DIR)
	mkdir -p $(INSTALL_DIR)
	mkdir -p $(MAN_DIR)/man1
	install -m 644 share/man/kodev.1 $(MAN_DIR)/man1/kodev.1
	install -m 555 $(KORE) $(INSTALL_DIR)/$(KORE)
	install -m 644 kore.features $(SHARE_DIR)/features
	install -m 644 include/kore/*.h $(INCLUDE_DIR)
	$(MAKE) -C kodev install

uninstall:
	rm -f $(INSTALL_DIR)/$(KORE)
	rm -rf $(INCLUDE_DIR)
	rm -rf $(SHARE_DIR)
	$(MAKE) -C kodev uninstall

$(OBJDIR)/%.o: src/%.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	rm -f $(VERSION)
	find . -type f -name \*.o -exec rm {} \;
	rm -rf $(KORE) $(OBJDIR) kore.features
	$(MAKE) -C kodev clean

releng-build-examples:
	rm -rf /tmp/kore_releng
	$(MAKE) clean
	$(MAKE) PYTHON=1 PGSQL=1 TASKS=1 PREFIX=/tmp/kore_releng
	$(MAKE) install PREFIX=/tmp/kore_releng
	$(MAKE) -C examples

.PHONY: all clean force

=== examples/Makefile ===
#
# Build all relevant examples.
# This only exists to quickly test building all examples.
#
# Kore must be built with PGSQL=1 TASKS=1 PYTHON=1 to get all
# of the below examples to build correctly.
#
# Don't run this directly, run it from the top level as
# $ make releng-build-examples
#

CURDIR=		$(shell pwd)
KODEV=		/tmp/kore_releng/bin/kodev

EXAMPLES=	async-curl \
		cookies \
		cpp \
		generic \
		headers \
		integers \
		memtag \
		messaging \
		nohttp \
		parameters \
		pgsql \
		pgsql-sync \
		pipe_task \
		python-async \
		python-echo \
		python-pgsql \
		sse \
		tasks \
		tls-proxy \
		upload \
		video_stream \
		websocket \

all:
	@for example in $(EXAMPLES); do \
		cd $$example; \
		$(KODEV) clean && $(KODEV) build || exit 1; \
		cd $(CURDIR); \
	done

clean:
	@for example in $(EXAMPLES); do \
		cd $$example; \
		$(KODEV) clean; \
		cd $(CURDIR); \
	done

=== kodev/Makefile ===
# kodev Makefile

CC?=cc
PREFIX?=/usr/local
OBJDIR?=obj
KODEV=kodev
INSTALL_DIR=$(PREFIX)/bin

S_SRC=	../src/cli.c

CFLAGS+=-Wall -Werror -Wstrict-prototypes -Wmissing-prototypes
CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
CFLAGS+=-Wsign-compare -Iincludes -std=c99 -pedantic
CFLAGS+=-DPREFIX='"$(PREFIX)"'
LDFLAGS=-lcrypto

ifneq ("$(NOOPT)", "")
	CFLAGS+=-O0
else
	CFLAGS+=-O2
endif

OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
ifeq ("$(OSNAME)", "darwin")
	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
else ifeq ("$(OSNAME)", "linux")
	CFLAGS+=-D_GNU_SOURCE=1
endif

S_OBJS=	$(S_SRC:../src/%.c=$(OBJDIR)/%.o)

$(KODEV): $(OBJDIR) $(S_OBJS)
	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KODEV)

$(OBJDIR):
	@mkdir -p $(OBJDIR)

install: $(KODEV)
	mkdir -p $(INSTALL_DIR)
	install -m 555 $(KODEV) $(INSTALL_DIR)/$(KODEV)

uninstall:
	rm -f $(INSTALL_DIR)/$(KODEV)

$(OBJDIR)/%.o: ../src/%.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	find . -type f -name \*.o -exec rm {} \;
	rm -rf $(KODEV) $(OBJDIR)

.PHONY: all clean

=== debian/changelog ===
kore (3.3.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/rules: Remove trailing whitespaces

  [ Shih-Yuan Lee (FourDollars) ]
  * Bump to 3.3.1. (Closes: #945098)
  * d/p/debian.patch: Adjust the patch for 3.3.1.
  * d/p/maybe-uninitialized.patch,
    d/p/Add-support-for-openssl-1.1.0-release-line.patch,
    d/p/Deal-with-the-Host-header-in-a-way-IPv6-hosts-work.patch:
    Drop patches from upstream
  * d/control: Update Standards-Version to 4.4.1.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Mon, 01 Oct 2018 09:40:24 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>
 Build-Depends: debhelper (>= 9.0.0), libssl-dev, libpq-dev
-Standards-Version: 4.1.4.2
+Standards-Version: 4.4.1
 Homepage: https://kore.io
 Vcs-Git: https://salsa.debian.org/debian/kore.git
 Vcs-Browser: https://salsa.debian.org/debian/kore

=== debian/watch ===
version=3

https://github.com/jorisvink/kore/releases .*/download/.*-release/kore-(.*)-release\.tar\.gz

## kore 4.0.1

=== Makefile ===
--- 
+++ 
@@ -1,21 +1,25 @@
 # Kore Makefile
 
 CC?=cc
+DESTDIR?=
 PREFIX?=/usr/local
 OBJDIR?=obj
 KORE=kore
 KODEV=kodev/kodev
 KORE_CRYPTO?=crypto
 INSTALL_DIR=$(PREFIX)/bin
-MAN_DIR=$(PREFIX)/share/man
+MAN_DIR?=$(PREFIX)/share/man
 SHARE_DIR=$(PREFIX)/share/kore
 INCLUDE_DIR=$(PREFIX)/include/kore
 
+GENERATED=
+PLATFORM=platform.h
 VERSION=src/version.c
+PYTHON_CURLOPT=misc/curl/python_curlopt.h
 
 S_SRC=	src/kore.c src/buf.c src/config.c src/connection.c \
-	src/domain.c src/filemap.c src/fileref.c src/mem.c src/msg.c \
-	src/module.c src/net.c src/pool.c src/runtime.c src/timer.c \
+	src/domain.c src/filemap.c src/fileref.c src/json.c src/mem.c \
+	src/msg.c src/module.c src/net.c src/pool.c src/runtime.c src/timer.c \
 	src/utils.c src/worker.c src/keymgr.c $(VERSION)
 
 FEATURES=
@@ -23,14 +27,15 @@
 
 CFLAGS+=-Wall -Werror -Wstrict-prototypes -Wmissing-prototypes
 CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
-CFLAGS+=-Wsign-compare -Iinclude/kore -std=c99 -pedantic
+CFLAGS+=-Wsign-compare -Iinclude/kore -I$(OBJDIR) -std=c99 -pedantic
+CFLAGS+=-Wtype-limits
 CFLAGS+=-DPREFIX='"$(PREFIX)"' -fstack-protector-all
 
 ifneq ("$(OPENSSL_PATH)", "")
 CFLAGS+=-I$(OPENSSL_PATH)/include
-LDFLAGS=-rdynamic -L$(OPENSSL_PATH) -lssl -l$(KORE_CRYPTO)
-else
-LDFLAGS=-rdynamic -lssl -l$(KORE_CRYPTO)
+LDFLAGS+=-rdynamic -L$(OPENSSL_PATH)/lib -lssl -l$(KORE_CRYPTO)
+else
+LDFLAGS+=-rdynamic -lssl -l$(KORE_CRYPTO)
 endif
 
 ifneq ("$(KORE_SINGLE_BINARY)", "")
@@ -41,7 +46,6 @@
 ifneq ("$(DEBUG)", "")
 	CFLAGS+=-DKORE_DEBUG -g
 	FEATURES+=-DKORE_DEBUG
-	NOOPT=1
 endif
 
 ifneq ("$(NOOPT)", "")
@@ -60,16 +64,6 @@
 else
 	S_SRC+= src/auth.c src/accesslog.c src/http.c \
 		src/validator.c src/websocket.c
-endif
-
-ifneq ("$(NOTLS)", "")
-	CFLAGS+=-DKORE_NO_TLS
-	FEATURES+=-DKORE_NO_TLS
-	ifneq ("$(NOHTTP)", "")
-		LDFLAGS=-rdynamic
-	else
-		LDFLAGS=-rdynamic -l$(KORE_CRYPTO)
-	endif
 endif
 
 ifneq ("$(PGSQL)", "")
@@ -97,8 +91,9 @@
 
 ifneq ("$(PYTHON)", "")
 	S_SRC+=src/python.c
-	KORE_PYTHON_LIB?=$(shell python3-config --ldflags)
-	KORE_PYTHON_INC?=$(shell python3-config --includes)
+	GENERATED+=$(PYTHON_CURLOPT)
+	KORE_PYTHON_LIB?=$(shell ./misc/python3-config.sh --ldflags)
+	KORE_PYTHON_INC?=$(shell ./misc/python3-config.sh --includes)
 	LDFLAGS+=$(KORE_PYTHON_LIB)
 	CFLAGS+=$(KORE_PYTHON_INC) -DKORE_USE_PYTHON
 	FEATURES+=-DKORE_USE_PYTHON
@@ -111,10 +106,17 @@
 	KORE_CURL_INC=-I/usr/local/include
 endif
 
+ifneq ("$(ACME)", "")
+	S_SRC+=src/acme.c
+	CURL=1
+	CFLAGS+=-DKORE_USE_ACME
+	FEATURES+=-DKORE_USE_ACME
+endif
+
 ifneq ("$(CURL)", "")
 	S_SRC+=src/curl.c
-	KORE_CURL_LIB?=$(shell pkg-config --libs libcurl)
-	KORE_CURL_INC?=$(shell pkg-config --cflags libcurl)
+	KORE_CURL_LIB?=$(shell curl-config --libs)
+	KORE_CURL_INC?=$(shell curl-config --cflags)
 	LDFLAGS+=$(KORE_CURL_LIB)
 	CFLAGS+=$(KORE_CURL_INC) -DKORE_USE_CURL
 	FEATURES+=-DKORE_USE_CURL
@@ -133,7 +135,7 @@
 else ifeq ("$(OSNAME)", "linux")
 	CFLAGS+=-D_GNU_SOURCE=1 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
 	LDFLAGS+=-ldl
-	S_SRC+=src/linux.c
+	S_SRC+=src/linux.c src/seccomp.c
 else
 	S_SRC+=src/bsd.c
 	ifneq ("$(JSONRPC)", "")
@@ -144,7 +146,15 @@
 
 S_OBJS=	$(S_SRC:src/%.c=$(OBJDIR)/%.o)
 
-all: $(VERSION) $(KORE) $(KODEV)
+all: $(PLATFORM) $(GENERATED) $(VERSION) $(KORE) $(KODEV)
+
+$(PLATFORM): $(OBJDIR) force
+	@if [ -f misc/$(OSNAME)-platform.sh ]; then \
+		misc/$(OSNAME)-platform.sh > $(OBJDIR)/$(PLATFORM) ; \
+	fi
+
+$(PYTHON_CURLOPT): $(OBJDIR) force
+	@cp $(PYTHON_CURLOPT) $(OBJDIR)
 
 $(VERSION): force
 	@if [ -d .git ]; then \
@@ -168,7 +178,7 @@
 	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KORE)
 	@echo $(FEATURES) $(FEATURES_INC) > kore.features
 
-objects: $(OBJDIR) $(S_OBJS)
+objects: $(OBJDIR) $(PLATFORM) $(GENERATED) $(S_OBJS)
 	@echo $(LDFLAGS) > $(OBJDIR)/ldflags
 	@echo "$(FEATURES) $(FEATURES_INC)" > $(OBJDIR)/features
 
@@ -176,14 +186,14 @@
 	@mkdir -p $(OBJDIR)
 
 install:
-	mkdir -p $(SHARE_DIR)
-	mkdir -p $(INCLUDE_DIR)
-	mkdir -p $(INSTALL_DIR)
-	mkdir -p $(MAN_DIR)/man1
-	install -m 644 share/man/kodev.1 $(MAN_DIR)/man1/kodev.1
-	install -m 555 $(KORE) $(INSTALL_DIR)/$(KORE)
-	install -m 644 kore.features $(SHARE_DIR)/features
-	install -m 644 include/kore/*.h $(INCLUDE_DIR)
+	mkdir -p $(DESTDIR)$(SHARE_DIR)
+	mkdir -p $(DESTDIR)$(INCLUDE_DIR)
+	mkdir -p $(DESTDIR)$(INSTALL_DIR)
+	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
+	install -m 644 share/man/kodev.1 $(DESTDIR)$(MAN_DIR)/man1/kodev.1
+	install -m 555 $(KORE) $(DESTDIR)$(INSTALL_DIR)/$(KORE)
+	install -m 644 kore.features $(DESTDIR)$(SHARE_DIR)/features
+	install -m 644 include/kore/*.h $(DESTDIR)$(INCLUDE_DIR)
 	$(MAKE) -C kodev install
 
 uninstall:
@@ -194,6 +204,8 @@
 
 $(OBJDIR)/%.o: src/%.c
 	$(CC) $(CFLAGS) -c $< -o $@
+
+src/python.c: $(PYTHON_CURLOPT)
 
 clean:
 	rm -f $(VERSION)

=== kodev/Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 PREFIX?=/usr/local
 OBJDIR?=obj
 KODEV=kodev
+DESTDIR?=
 INSTALL_DIR=$(PREFIX)/bin
 
 S_SRC=	../src/cli.c
@@ -18,6 +19,11 @@
 	CFLAGS+=-O0
 else
 	CFLAGS+=-O2
+endif
+
+ifneq ("$(MINIMAL)", "")
+	CFLAGS+=-DKODEV_MINIMAL
+	LDFLAGS=
 endif
 
 OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
@@ -37,8 +43,8 @@
 	@mkdir -p $(OBJDIR)
 
 install: $(KODEV)
-	mkdir -p $(INSTALL_DIR)
-	install -m 555 $(KODEV) $(INSTALL_DIR)/$(KODEV)
+	mkdir -p $(DESTDIR)$(INSTALL_DIR)
+	install -m 555 $(KODEV) $(DESTDIR)$(INSTALL_DIR)/$(KODEV)
 
 uninstall:
 	rm -f $(INSTALL_DIR)/$(KODEV)

=== debian/changelog ===
kore (4.0.1-5) unstable; urgency=medium

  * d/p/Allow-the-clock_nanosleep-syscall-it-is-required-for.patch,
    d/p/Conditionally-allow-syscalls-required-to-run-on-arm.patch,
    d/p/series: Backport more fixes from upstream for arm.
  * d/t/myapp: Make myapp quit when seccomp is not in filter mode.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Wed, 07 Oct 2020 23:25:39 +0800

kore (4.0.1-4) unstable; urgency=medium

  * d/t/myapp: Check if seccomp is 2 (i.e. filter mode).
  * d/t/myapp: Check /dev/urandom and polish the test script.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Mon, 28 Sep 2020 21:54:19 +0800

kore (4.0.1-3) unstable; urgency=medium

  * d/p/Add-support-for-logging-seccomp-violations-on-arm.patch,
    d/p/series: Fix the compilation error on armel and armhf.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Thu, 24 Sep 2020 10:14:00 +0800

kore (4.0.1-2) unstable; urgency=medium

  * d/p/Fix-the-compilation-error-when-using-make-j8.patch,
    d/rules: Remove the workaround of using make -j1 and apply the real fix.
  * d/t/control,
    d/t/myapp-clang: Check gcc and clang instead of c-compiler.
  * d/p/Add-missing-tests-for-SYS_mmap-fixes-the-build-on-ar.patch,
    d/p/series: Fix the compilation error on armel and armhf.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Wed, 23 Sep 2020 00:42:50 +0800

kore (4.0.1-1) unstable; urgency=medium

  [ Shih-Yuan Lee (FourDollars) ]
  * d/watch: Update the URL to scan.
  * d/copyright: Update the source link and the maintainer's email.
  * Bump to 4.0.1.
  * d/p/debian.patch: Adjust the patch for 4.0.1.
  * d/t/control, d/t/myapp: Add autopkgtests.
  * d/p/debian.patch: Avoid getting the version from git.
  * d/rules: Use make -j1.
  * d/t/myapp: Make myapp gracefully shutdown.
  * d/control: It only supports amd64, armhf, armel and arm64.

  [ Debian Janitor ]
  * Bump debhelper from deprecated 9 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.5.0, no changes needed.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Wed, 25 Dec 2019 16:14:06 +0800

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: httpd
 Priority: optional
 Maintainer: Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>
-Build-Depends: debhelper (>= 9.0.0), libssl-dev, libpq-dev
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 12), libssl-dev, libpq-dev
+Standards-Version: 4.5.0
 Homepage: https://kore.io
 Vcs-Git: https://salsa.debian.org/debian/kore.git
 Vcs-Browser: https://salsa.debian.org/debian/kore
 
 Package: kore
-Architecture: any
+Architecture: amd64 armhf armel arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}, libc-dev, libssl-dev, libpq-dev
 Recommends: gcc | clang | c-compiler
 Suggests: postgresql

## kore 4.1.0

=== Makefile ===
--- 
+++ 
@@ -6,21 +6,24 @@
 OBJDIR?=obj
 KORE=kore
 KODEV=kodev/kodev
+KOREPATH?=$(shell pwd)
 KORE_CRYPTO?=crypto
 INSTALL_DIR=$(PREFIX)/bin
 MAN_DIR?=$(PREFIX)/share/man
 SHARE_DIR=$(PREFIX)/share/kore
 INCLUDE_DIR=$(PREFIX)/include/kore
 
+TOOLS=	kore-serve
+
 GENERATED=
 PLATFORM=platform.h
-VERSION=src/version.c
+VERSION=$(OBJDIR)/version.c
 PYTHON_CURLOPT=misc/curl/python_curlopt.h
 
 S_SRC=	src/kore.c src/buf.c src/config.c src/connection.c \
 	src/domain.c src/filemap.c src/fileref.c src/json.c src/mem.c \
 	src/msg.c src/module.c src/net.c src/pool.c src/runtime.c src/timer.c \
-	src/utils.c src/worker.c src/keymgr.c $(VERSION)
+	src/utils.c src/worker.c src/keymgr.c
 
 FEATURES=
 FEATURES_INC=
@@ -145,6 +148,7 @@
 endif
 
 S_OBJS=	$(S_SRC:src/%.c=$(OBJDIR)/%.o)
+S_OBJS+=$(OBJDIR)/version.o
 
 all: $(PLATFORM) $(GENERATED) $(VERSION) $(KORE) $(KODEV)
 
@@ -171,7 +175,7 @@
 		exit 1; \
 	fi
 
-$(KODEV):
+$(KODEV): src/cli.c
 	$(MAKE) -C kodev
 
 $(KORE): $(OBJDIR) $(S_OBJS)
@@ -195,17 +199,63 @@
 	install -m 644 kore.features $(DESTDIR)$(SHARE_DIR)/features
 	install -m 644 include/kore/*.h $(DESTDIR)$(INCLUDE_DIR)
 	$(MAKE) -C kodev install
+	$(MAKE) install-sources
+
+install-sources:
+	@mkdir -p $(DESTDIR)$(SHARE_DIR)
+	@cp Makefile $(DESTDIR)$(SHARE_DIR)
+	@cp -R src $(DESTDIR)$(SHARE_DIR)
+	@cp -R include $(DESTDIR)$(SHARE_DIR)
+	@cp -R misc $(DESTDIR)$(SHARE_DIR)
+	@if [ -d .git ]; then \
+		GIT_REVISION=`git rev-parse --short=8 HEAD`; \
+		GIT_BRANCH=`git rev-parse --abbrev-ref HEAD`; \
+		rm -f $(VERSION); \
+		echo "$$GIT_BRANCH-$$GIT_REVISION" > \
+		    $(DESTDIR)$(SHARE_DIR)/RELEASE; \
+	elif [ -f RELEASE ]; then \
+		cp RELEASE $(DESTDIR)$(SHARE_DIR); \
+	else \
+		echo "No version information found (no .git or RELEASE)"; \
+		exit 1; \
+	fi
 
 uninstall:
-	rm -f $(INSTALL_DIR)/$(KORE)
-	rm -rf $(INCLUDE_DIR)
-	rm -rf $(SHARE_DIR)
+	rm -f $(DESTDIR)$(INSTALL_DIR)/$(KORE)
+	rm -rf $(DESTDIR)$(INCLUDE_DIR)
+	rm -rf $(DESTDIR)$(SHARE_DIR)
 	$(MAKE) -C kodev uninstall
+
+tools-build: $(KODEV)
+	for t in $(TOOLS); do \
+		cd tools/$$t; \
+		env \
+		    KODEV_OUTPUT=$(KOREPATH) \
+		    KORE_SOURCE=$(KOREPATH) \
+		    KORE_BUILD_FLAVOR=$(OSNAME) \
+		    $(KOREPATH)/$(KODEV) build; \
+		cd $(KOREPATH); \
+	done
+
+tools-clean: $(KODEV)
+	for t in $(TOOLS); do \
+		cd tools/$$t; \
+		$(KOREPATH)/$(KODEV) clean; \
+		cd $(KOREPATH); \
+	done
+
+tools-install:
+	mkdir -p $(DESTDIR)$(INSTALL_DIR)
+	for t in $(TOOLS); do \
+		install -m 555 $$t $(DESTDIR)$(INSTALL_DIR)/$$t; \
+	done
 
 $(OBJDIR)/%.o: src/%.c
 	$(CC) $(CFLAGS) -c $< -o $@
 
 src/python.c: $(PYTHON_CURLOPT)
+
+src/seccomp.c: $(PLATFORM)
 
 clean:
 	rm -f $(VERSION)

=== kodev/Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 	install -m 555 $(KODEV) $(DESTDIR)$(INSTALL_DIR)/$(KODEV)
 
 uninstall:
-	rm -f $(INSTALL_DIR)/$(KODEV)
+	rm -f $(DESTDIR)$(INSTALL_DIR)/$(KODEV)
 
 $(OBJDIR)/%.o: ../src/%.c
 	$(CC) $(CFLAGS) -c $< -o $@

=== debian/changelog ===
kore (4.1.0-6) unstable; urgency=medium

  * debian/control: Update Debian policy version to 4.6.0.
  * debian/control: Fix the extended-description-line-too-long.
  * debian/changelog: Fix the debian-changelog-line-too-long.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Sun, 19 Dec 2021 11:53:06 +0800

kore (4.1.0-5) unstable; urgency=medium

  * debian/patches/0002-Add-SYS_newfstatat-to-keymgr-seccomp-rules.patch:
    Fix the failure with glibc >= 2.33. (Closes: #1001558)
  * debian/patches/0003-Handle-PGRES_PIPELINE_-for-PQResult.patch,
    debian/patches/0004-wrap-pipeline-in-PG_VERSION_NUM-140000.patch:
    Fix the compilation error with postgresql 14. (Closes: #1001312)
  * debian/patches/0005-remove-support-for-older-openssl-apis-in-keymgr.patch,
    debian/patches/0006-Get-kore-to-at-least-build-with-openssl-3.patch:
    Fix the compilation error with openssl 3. (Closes: #1001312)
  * debian/tests/myapp: Use the timeout command to kill the process.
    (Closes: #992535)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Sun, 19 Dec 2021 01:15:22 +0800

kore (4.1.0-4) unstable; urgency=medium

  * debian/tests/myapp: Adjust the test script to avoid waiting forever again.
    (Closes: #992535)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Sat, 21 Aug 2021 12:30:04 +0800

kore (4.1.0-3) unstable; urgency=medium

  * debian/tests/myapp: Adjust the test script to avoid waiting forever.
    (Closes: #989749)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Tue, 22 Jun 2021 00:05:14 +0800

kore (4.1.0-2) unstable; urgency=medium

  * d/control: Update Debian policy version to 4.5.1.
  * d/copyright: Update years.
  * d/p/Fix-the-compilation-error-when-using-make-j8.patch: Drop this patch.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Wed, 03 Mar 2021 14:43:32 +0800

kore (4.1.0-1) unstable; urgency=medium

  * Bump to 4.1.0.
  * d/control,
    d/kore.1: Update the description.
  * d/p/*: Remove unnecessary patches and refresh patches.

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Tue, 02 Mar 2021 22:57:05 +0800

=== debian/rules ===
--- 
+++ 
@@ -8,4 +8,4 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ 
+	dh $@

=== debian/tests/control ===
Tests: myapp
Depends: @, wget, gcc
Restrictions: allow-stderr

Tests: myapp-clang
Depends: @, wget, clang
Restrictions: allow-stderr

## kore 4.2.3

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,8 @@
 MAN_DIR?=$(PREFIX)/share/man
 SHARE_DIR=$(PREFIX)/share/kore
 INCLUDE_DIR=$(PREFIX)/include/kore
+TLS_BACKEND?=openssl
+KORE_TMPDIR?=/tmp
 
 TOOLS=	kore-serve
 
@@ -21,9 +23,10 @@
 PYTHON_CURLOPT=misc/curl/python_curlopt.h
 
 S_SRC=	src/kore.c src/buf.c src/config.c src/connection.c \
-	src/domain.c src/filemap.c src/fileref.c src/json.c src/mem.c \
-	src/msg.c src/module.c src/net.c src/pool.c src/runtime.c src/timer.c \
-	src/utils.c src/worker.c src/keymgr.c
+	src/domain.c src/filemap.c src/fileref.c src/json.c src/log.c \
+	src/mem.c src/msg.c src/module.c src/net.c src/pool.c src/runtime.c \
+	src/sha1.c src/sha2.c src/timer.c src/utils.c src/worker.c
+S_SRC+= src/tls_$(TLS_BACKEND).c
 
 FEATURES=
 FEATURES_INC=
@@ -31,23 +34,35 @@
 CFLAGS+=-Wall -Werror -Wstrict-prototypes -Wmissing-prototypes
 CFLAGS+=-Wmissing-declarations -Wshadow -Wpointer-arith -Wcast-qual
 CFLAGS+=-Wsign-compare -Iinclude/kore -I$(OBJDIR) -std=c99 -pedantic
-CFLAGS+=-Wtype-limits
+CFLAGS+=-Wtype-limits -fno-common
 CFLAGS+=-DPREFIX='"$(PREFIX)"' -fstack-protector-all
 
-ifneq ("$(OPENSSL_PATH)", "")
-CFLAGS+=-I$(OPENSSL_PATH)/include
-LDFLAGS+=-rdynamic -L$(OPENSSL_PATH)/lib -lssl -l$(KORE_CRYPTO)
-else
-LDFLAGS+=-rdynamic -lssl -l$(KORE_CRYPTO)
+LDFLAGS+=-rdynamic
+
+ifeq ("$(TLS_BACKEND)", "openssl")
+	S_SRC+=src/keymgr_openssl.c
+	CFLAGS+=-DTLS_BACKEND_OPENSSL
+	FEATURES+=-DTLS_BACKEND_OPENSSL
+
+	ifneq ("$(OPENSSL_PATH)", "")
+		CFLAGS+=-I$(OPENSSL_PATH)/include
+		LDFLAGS+=-L$(OPENSSL_PATH)/lib -lssl -l$(KORE_CRYPTO)
+	else
+		LDFLAGS+=-lssl -l$(KORE_CRYPTO)
+	endif
+else
+ifneq ("$(ACME)", "")
+$(error ACME not supported under TLS backend $(TLS_BACKEND))
+endif
 endif
 
 ifneq ("$(KORE_SINGLE_BINARY)", "")
-	CFLAGS+=-DKORE_SINGLE_BINARY
+	CFLAGS+=-DKORE_SINGLE_BINARY -DKORE_TMPDIR='"$(KORE_TMPDIR)"'
 	FEATURES+=-DKORE_SINGLE_BINARY
 endif
 
 ifneq ("$(DEBUG)", "")
-	CFLAGS+=-DKORE_DEBUG -g
+	CFLAGS+=-g
 	FEATURES+=-DKORE_DEBUG
 endif
 
@@ -66,7 +81,7 @@
 	FEATURES+=-DKORE_NO_HTTP
 else
 	S_SRC+= src/auth.c src/accesslog.c src/http.c \
-		src/validator.c src/websocket.c
+		src/route.c src/validator.c src/websocket.c
 endif
 
 ifneq ("$(PGSQL)", "")
@@ -132,8 +147,12 @@
 endif
 
 ifeq ("$(OSNAME)", "darwin")
-	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
-	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
+	ifeq ("$(TLS_BACKEND)", "openssl")
+		OSSL_INCL=$(shell pkg-config openssl --cflags)
+		CFLAGS+=$(OSSL_INCL)
+		LDFLAGS+=$(shell pkg-config openssl --libs)
+		FEATURES_INC+=$(OSSL_INCL)
+	endif
 	S_SRC+=src/bsd.c
 else ifeq ("$(OSNAME)", "linux")
 	CFLAGS+=-D_GNU_SOURCE=1 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
@@ -160,7 +179,7 @@
 $(PYTHON_CURLOPT): $(OBJDIR) force
 	@cp $(PYTHON_CURLOPT) $(OBJDIR)
 
-$(VERSION): force
+$(VERSION): $(OBJDIR) force
 	@if [ -d .git ]; then \
 		GIT_REVISION=`git rev-parse --short=8 HEAD`; \
 		GIT_BRANCH=`git rev-parse --abbrev-ref HEAD`; \
@@ -174,12 +193,15 @@
 		echo "No version information found (no .git or RELEASE)"; \
 		exit 1; \
 	fi
+	@printf "const char *kore_build_date = \"%s\";\n" \
+	    `date +"%Y-%m-%d"` >> $(VERSION);
 
 $(KODEV): src/cli.c
 	$(MAKE) -C kodev
 
 $(KORE): $(OBJDIR) $(S_OBJS)
 	$(CC) $(S_OBJS) $(LDFLAGS) -o $(KORE)
+	@echo $(LDFLAGS) > kore.linker
 	@echo $(FEATURES) $(FEATURES_INC) > kore.features
 
 objects: $(OBJDIR) $(PLATFORM) $(GENERATED) $(S_OBJS)
@@ -197,7 +219,9 @@
 	install -m 644 share/man/kodev.1 $(DESTDIR)$(MAN_DIR)/man1/kodev.1
 	install -m 555 $(KORE) $(DESTDIR)$(INSTALL_DIR)/$(KORE)
 	install -m 644 kore.features $(DESTDIR)$(SHARE_DIR)/features
+	install -m 644 kore.linker $(DESTDIR)$(SHARE_DIR)/linker
 	install -m 644 include/kore/*.h $(DESTDIR)$(INCLUDE_DIR)
+	install -m 644 misc/ffdhe4096.pem $(DESTDIR)$(SHARE_DIR)/ffdhe4096.pem
 	$(MAKE) -C kodev install
 	$(MAKE) install-sources
 
@@ -253,6 +277,8 @@
 $(OBJDIR)/%.o: src/%.c
 	$(CC) $(CFLAGS) -c $< -o $@
 
+src/kore.c: $(VERSION)
+
 src/python.c: $(PYTHON_CURLOPT)
 
 src/seccomp.c: $(PLATFORM)
@@ -260,7 +286,7 @@
 clean:
 	rm -f $(VERSION)
 	find . -type f -name \*.o -exec rm {} \;
-	rm -rf $(KORE) $(OBJDIR) kore.features
+	rm -rf $(KORE) $(OBJDIR) kore.features kore.linker
 	$(MAKE) -C kodev clean
 
 releng-build-examples:

=== examples/Makefile ===
--- 
+++ 
@@ -25,9 +25,6 @@
 		pgsql \
 		pgsql-sync \
 		pipe_task \
-		python-async \
-		python-echo \
-		python-pgsql \
 		sse \
 		tasks \
 		tls-proxy \

=== kodev/Makefile ===
--- 
+++ 
@@ -28,8 +28,8 @@
 
 OSNAME=$(shell uname -s | sed -e 's/[-_].*//g' | tr A-Z a-z)
 ifeq ("$(OSNAME)", "darwin")
-	CFLAGS+=-I/opt/local/include/ -I/usr/local/opt/openssl/include
-	LDFLAGS+=-L/opt/local/lib -L/usr/local/opt/openssl/lib
+	CFLAGS+=$(shell pkg-config openssl --cflags)
+	LDFLAGS+=$(shell pkg-config openssl --libs)
 else ifeq ("$(OSNAME)", "linux")
 	CFLAGS+=-D_GNU_SOURCE=1
 endif

=== debian/changelog ===
kore (4.2.3-2) unstable; urgency=medium

  * debian: feat(seccomp): update syscall lists and fix tasks example
  * debian: fix(patch): Correct typo in PGRES_TUPLES_CHUNK patch name and content (Closes: #1081081)
  * debian: fix(pgsql): Correctly handle PGRES_TUPLES_CHUNK for PostgreSQL 17 (Closes: #1081081)
  * debian: refactor(debian) Rename debian.patch to follow a numbered series

 -- Shih-Yuan Lee (FourDollars) <sylee@canonical.com>  Sat, 05 Jul 2025 13:27:45 +0800

kore (4.2.3-1) unstable; urgency=medium

  * Bump to 4.2.3.
  * d/p/0*.patch: Drop all patches from the upstream.
  * d/p/debian.patch: Refresh debian.patch.
  * d/p/0002-pgsql-Handle-PGRES_TUPLES_CHUNK-for-PostgreSQL-17.patch:
    Fix the problem for PostgreSQL 17+. (Closes: #1081081)
  * d/p/0003-conf-Correct-TLS-certificate-filenames-in-example-co.patch:
    Correct TLS certificate filenames in example config (Closes: #1033711)
  * debian/patches/0004-Disable-deprecated-warnings-for-OpenSSL-3.patch,
    debian/patches/0005-Change-how-we-handle-EVP_PKEY-for-privsep.patch:
    Cherry-pick upstream OpenSSL 3.x compatibility patches (Closes: #1033711)
  * debian: Correctly wait for Kore parent process in autopkgtests
  * debian: Improve Seccomp verification in myapp tests
  * debian: Improve service readiness check in myapp tests
  * debian: Bump debhelper compat level and standards version

 -- Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>  Fri, 04 Jul 2025 16:47:25 +0000

=== debian/control ===
Source: kore
Section: httpd
Priority: optional
Maintainer: Shih-Yuan Lee (FourDollars) <fourdollars@debian.org>
Build-Depends: debhelper-compat (= 13), libssl-dev, libpq-dev
Standards-Version: 4.7.2
Homepage: https://kore.io
Vcs-Git: https://salsa.debian.org/debian/kore.git
Vcs-Browser: https://salsa.debian.org/debian/kore

Package: kore
Architecture: amd64 armhf armel arm64
Depends: ${shlibs:Depends}, ${misc:Depends}, libc-dev, libssl-dev, libpq-dev
Recommends: gcc | clang | c-compiler
Suggests: postgresql
Description: Web platform for writing scalable, concurrent APIs in C or Python
 Kore is an easy to use web platform for writing scalable, concurrent APIs in C
 or Python. Its primary goals are security, scalability and allowing rapid
 development and deployment of such APIs. Because of this Kore is an ideal
 candidate for building robust, scalable and secure web things.

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 export TASKS=1
 export PGSQL=1
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_CFLAGS_APPEND=-Wno-deprecated-declarations -Wno-discarded-qualifiers
 
 %:
 	dh $@

=== debian/tests/control ===
Tests: myapp
Depends: @, wget, gcc, psmisc
Restrictions: allow-stderr

Tests: myapp-clang
Depends: @, wget, clang, psmisc
Restrictions: allow-stderr

=== debian/watch ===
version=4

https://kore.io/source .*/releases/kore-(.*).tar.gz
